<?php
/* Copyright 2008-2009 Vincent Prat */


/**
* Class to dispatch page requests
* 
* @author Vincent Prat
*/

class UMPR_AdminInterface {
    
    /**
    * Constructor
    */
    function UMPR_AdminInterface() {
        add_action('admin_menu', array(&$this, 'add_menu'));  
    }
        
    /**
    * Add the menu to the administration interface
    */
    function add_menu() {     
		add_management_page(
			__('UM Password Reset', 'umpr'), __('UM Password Reset', 'umpr'), 
			8,
			'um-password-reset', 
			array (&$this, 'menu_callback'));  
	}
    
    /**
    * Function called on a menu click to display the appropriate view
    */
    function menu_callback() {   
    	$view = $this->get_view();
		if ($view)
			$view->show_view();
    }
    
    /**
    * Get the view object corresponding to the page we want to show
    */
    function get_view() {
    	$view = $this->get_view_parameter();
        $chosen_view = $this;
            
        switch ($view){
            case "um-password-reset":
                include_once(dirname(__FILE__) . '/PasswordResetPage.php' );
                $chosen_view = new UMPR_PasswordResetPage();
                break;
            case "umpr-plugin-about-view":
                include_once(dirname(__FILE__) . '/AboutPage.php' );
                $chosen_view = new UMPR_AboutPage();
                break;
            default:
                $chosen_view = null;
        }
        
        return $chosen_view;
    }
        	
	/**
	 * Get the page from the GET or POST values
	 */
	function get_view_parameter() {
		if (isset($_GET['page']) && $_GET['page']=='um-password-reset' && isset($_GET['view'])) {
			return $_GET['view'];
		} else if (isset($_GET['page'])) {
			return $_GET['page'];
		} else {
			return $_POST['page'];
		}
	}
}
